#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Display RMC class definitions

use strict;
BEGIN { $::CSMDIR = '..'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();

$ENV{'CT_MANAGEMENT_SCOPE'}=1;

#my $isAction = exists($::in{dynTestButton});
GuiUtils->addHeader(undef, 3, 'RMC Classes');

# Process the buttons
if (exists($::in{trySelectButton}))
  {
	#print "<H3>Select String Query:  $::in{selectString}</H3>\n";
	#GuiUtils->runcmd("$GuiUtils::csmroot/bin/$lsCmd -w " . NodeUtils->quote($::in{selectString}), 1);
	#print "<P></P>\n";
	#&footer("nodegrp.cgi?groupName=$::in{groupName}&groupType=$::in{groupType}&selectString=$::in{selectString}&device=$::in{device}", "CSM $memName Groups");
	#return;
  }

# Get list of classes
my $classes = GuiUtils->runcmd('/usr/bin/lsrsrc -x');
@$classes = sort @$classes;

# Get the attributes for the selected class
#my ($groupName, $groupType, $memberList, $selectString, $genericChecked, $staticChecked, $dynamicChecked);
my @props;
my @dynprops;
my ($attrs, $resources, $displayDef, $displayRes, $headerstr);

if (!length($::in{displayType}) || $::in{displayType} eq 'definition') {
  $displayDef = 1;
  $headerstr = "Class Definition for $::in{classes}";
}
elsif ($::in{displayType} eq 'resources') {
  $displayRes = 1;
  $headerstr = "Resources for Class $::in{classes}";
}

if (exists($::in{classes})) {
  if ($displayDef) {
	# persistent attrs: program_name::display_name::group_name::properties::description::attribute_id::group_id::data_type::               variety_list::variety_count::   default_value
	# dynamic attrs:    program_name  display_name  group_name  properties  description  attribute_id  group_id  data_type  variable_type  variety_list  variety_count  init_value  min_value  max_value  expression  expression_description  rearm_expression  rearm_description  PTX_name
	# persistent: <TD>program_name</TD><TD>display_name</TD><TD>group_name</TD><TD>properties</TD><TD>description</TD><TD>attribute_id</TD><TD>group_id</TD><TD>data_type</TD><TD>variety_list</TD><TD>variety_count</TD><TD>default_value</TD>
	# dynamic:    <TD>program_name</TD><TD>display_name</TD><TD>group_name</TD><TD>properties</TD><TD>description</TD><TD>attribute_id</TD><TD>group_id</TD><TD>data_type</TD><TD>variable_type</TD><TD>variety_list</TD><TD>variety_count</TD><TD>init_value</TD><TD>min_value</TD><TD>max_value</TD><TD>expression</TD><TD>expression_description</TD><TD>rearm_expression</TD><TD>rearm_description</TD><TD>PTX_name</TD>
	my $classdef = GuiUtils->runcmd("/usr/bin/lsrsrcdef -xeA p -p 0 -D ':|:' $::in{classes}");
	my $classstr = join("\n", @$classdef);
	@props = split(/:\|:\n/, $classstr);
	#foreach my $l (@classes) { print "<p>line=$l</p>\n"; }
	
	$classdef = GuiUtils->runcmd("/usr/bin/lsrsrcdef -xeA d -p 0 -D ':|:' $::in{classes}");
	$classstr = join("\n", @$classdef);
	@dynprops = split(/:\|:\n/, $classstr);
  }
  elsif ($displayRes) {
	$attrs = GuiUtils->runcmd("/usr/bin/lsrsrcdef-api -r $::in{classes}");
	#$resources = GuiUtils->runcmd("/usr/bin/lsrsrc-api -i -D ':|:' -s $::in{classes}::::'*b0x0020'");
	$resources = GuiUtils->runcmd("/usr/bin/lsrsrc-api -i -D ':|:' -s $::in{classes}::::'*b0xffff'");
  }
}
#else            # no group selected
  #{
	# handle the case where we are returning from the trySelectButton or invoked from the action button on the main page
  #}
	
my $code = GuiUtils->processHTML('rmcclass-src.html');
eval $code;
if (length($@)) { print "<P>$@</P>"; }

&footer('.', 'Monitoring');


