#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Diagnose problems on the device

use strict;
BEGIN { $::CSMDIR = '..'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();

my $isAction = exists($::in{pingButton}) || exists($::in{testDshButton}) || exists($::in{runcmdButton}) || exists($::in{viewFileButton}) || exists($::in{syncTimeButton});

GuiUtils->addHeader(undef, 1, $isAction?'Run Diag Cmds':'Diagnose Device', $isAction);


if ($isAction) { print "<H2>Diagnostic Commands and Output:</H2>\n"; }

my $dshcmd = "/opt/csm/bin/dsh -s -n $::in{nodes}";
$::GUI_VERBOSE = 1;      # always want to show them the cmds we are running on this page
if (exists($::in{pingButton}))     # ping the node
  {
	GuiUtils->runcmd("ping -c 10 $::in{nodes}", 1, {NoVerbose=>1});
	#GuiUtils->runcmd('echo "Probing.  This may take a while...";/opt/diagnostics/bin/probemgr', 1, {NoVerbose=>1});
	#GuiUtils->runcmd('/home/bp/bin/slowoutput', 1, {NoVerbose=>1});
	#for (my $i=1; $i<=5; $i++) { print "<p>$i</p>\n";  sleep 5; }
  }
elsif (exists($::in{testDshButton}))     # run dsh date
  {
	GuiUtils->runcmd("$dshcmd date", 1);
  }
elsif (exists($::in{runcmdButton}))     # run dsh
  {
	GuiUtils->runcmd("$dshcmd $::in{runcmdInput}", 1);
  }
elsif (exists($::in{viewFileButton}))     # view a file
  {
	GuiUtils->runcmd(qq($dshcmd 'if [ -d "$::in{viewFileInput}" ]; then { /bin/ls "$::in{viewFileInput}"; } else { cat "$::in{viewFileInput}"; } fi'), 1);
  }
elsif (exists($::in{syncTimeButton}))     # set the node time to the mgmt svrs time
  {
	my ($sec,$min,$hour,$mday,$mon,$year) = gmtime();
	# the format for the date cmd is: %mnth%day%Hour%Min%Year.%Sec
	my $t = twoDigits($mon+1) . twoDigits($mday) . twoDigits($hour) . twoDigits($min) . ($year+1900) . '.' . twoDigits($sec);
	GuiUtils->runcmd("/opt/csm/bin/dsh -s -n $::in{nodes} 'date -u $t;date'", 1);
  }

if ($isAction) {
  print "<P><BR></P>\n";
  &footer("diag.cgi?nodes=" . &urlize($::in{nodes}), 'Diagnose Device');
}
else {       # show main page for diagnosing devices
  my $code = GuiUtils->processHTML('diag-src.html');
  eval $code;
  if (length($@)) { print "<P>$@</P>"; }
  &footer('.', 'Devices');
}
