#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Display the devices main page
# Note: in this script, nodes means devices

use strict;
BEGIN { $::CSMDIR = '..'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();

# Build node list
#my $nodeErr;
#my ($options, @nodes);

# Go to the page corresponding to the button
if ($::in{propButton}) { &redirect("properties.cgi?" . getParams()); }
elsif ($::in{defineButton}) { &redirect("definenode.cgi?" . getParams()); }
#elsif ($::in{updateButton}) { &redirect("update.cgi?" . getParams()); }
elsif ($::in{runcmdButton})
  {
	my $p = getParams();
	if ($p =~ /nodes=./) { &redirect("dsh.cgi?$p"); }          # some nodes were selected
	else { &redirect('../shell'); }                                  # no nodes selected
  }
#elsif ($::in{copyFilesButton}) { &redirect("dcp.cgi?" . getParams()); }
elsif ($::in{pingNodesButton}) { &redirect("dping.cgi?" . getParams()); }
elsif ($::in{createGroupButton}) { &redirect("../nodegrp.cgi?" . getParams() . "&groupType=staticType&device=on"); }
elsif ($::in{hwctrlButton})
  {
	my $hcp = getFirstNode();
	#&main::PrintHeader();
	#print "<p>hcp=$hcp</p>\n";
	if (length($hcp)) { &redirect("http://$hcp"); }
	#else { &redirect('jserror.cgi?error=' . &urlize("The HWControlPoint attribute is not defined for $node.")); }
  }
#elsif ($::in{softMaintButton}) { &redirect("softmaint/node.cgi?" . getParams()); }
elsif ($::in{diagButton}) { &redirect("diag.cgi?" . getParams()); }
# else they are coming to this page from elsewhere, so display it...


$::VERBOSE = $::GUI_VERBOSE;          # this will cause NodeUtils to show the cmds
$ENV{'CT_MANAGEMENT_SCOPE'}=1;
if (length($::config{CSM_NODE_PREFIX})) { $ENV{CSM_NODE_PREFIX} = $::config{CSM_NODE_PREFIX}; }

# Create title and header area
GuiUtils->addHeader(undef, 1);

if ($::in{removeButton}) {
  my @nodes;
  foreach my $k (keys %::in)
	  {
		if ($k =~ /^node\d+/) { push @nodes, $::in{$k}; }
	  }
  $::GUI_VERBOSE = 1;      # show them the cmd we are running
  GuiUtils->runcmd("$GuiUtils::csmroot/bin/rmhwdev -d " . join(',',@nodes), 1);
}

# Use the users cookie values as defaults if the corresponding value is not in the URL
my ($cookies) = &::un_urlize($ENV{HTTP_COOKIE}) =~ /devicepage=([^;]+)/;
my ($nodegrpCookie, $nodeRangeCookie) = split(/&/, $cookies);
if (!exists($::in{group}) && defined($nodegrpCookie)) { $::in{group} = $nodegrpCookie; }
if (!exists($::in{nodeRange}) && defined($nodeRangeCookie)) { $::in{nodeRange} = $nodeRangeCookie; }

# Get list of nodes and attributes and store for the HTML
my $noderef;
my %opthash = (ResourceClass => 'IBM.DeviceHwCtrl');
# this global var does not work until catskill
$::NODEGROUP_CLASS = 'IBM.DeviceGroup';     # this global variable is used by the group expansion functions in NodeUtils
if ($::in{nodeRange} =~ /\S/) { $noderef = NodeUtils->gatherNodeList([$::in{nodeRange}]); }
elsif (exists($::in{group}) && $::in{group} ne 'AllDevices')
  {
	# the $::NODEGROUP_CLASS global var does not work until catskill
	#$noderef = NodeUtils->gatherNodeList(undef, { NodeGrp => $::in{group} });
	$noderef = NodeUtils->runrmccmd('lsrsrc-api', "-i -D ':|:'", qq( -s IBM.DeviceGroup::"Name='$::in{group}'"::Name::ExpMemberList));
	my ($name, $nodelist) = $$noderef[0] =~ /^(.+):\|:\{(.*)\}$/;
	$noderef = [ split(/,/, $nodelist) ];
	$opthash{SkipResolve} = 1; $opthash{Res2Unres} = {};   # node groups are already resolved and unduped
  }
my $attrs = 'Name,DeviceType,StatusMethod,Status';
my $nodeAttrs;
if (defined($noderef) && !scalar(@$noderef)) { $nodeAttrs = []; }     # empty group
else { $nodeAttrs = NodeUtils->listNodeAttrs($noderef, $attrs, \%opthash); }

# Get list of node group names for the select menu
my @nodegrp;
chop(@nodegrp = `lsrsrc-api -i -D ':|:' -s IBM.DeviceGroup::::Name`);
@nodegrp = sort @nodegrp;

# Prepare the data structures for the html file
@$nodeAttrs = sort @$nodeAttrs;
#foreach my $n (@$nodeAttrs) { print "<P>$n</P>\n"; }

# Process the perl code within the HTML
#print '<P>Lsnode output: ' . join(',',@out) . '</P>';
my $code = GuiUtils->processHTML('index-src.html');
#open WEBCODE, '>/tmp/index-src.html'; select WEBCODE;
eval $code;
if (length($@)) { print "<P>$@</P>"; }

#if ($nodeErr) { print qq(<script language="JavaScript">if (document.getElementById('displayederror')) {alert('yes');} else {alert('no');}</script><div ID=displayederror></div>); }

&footer('', 'CSM Home');


sub getParams
  {
	my @nodes;
	my @params;
	foreach my $k (keys %::in)
	  {
		if ($k =~ /^node\d+/) { push @nodes, $::in{$k}; }
		elsif ($k ne 'nodegrps' && $k ne 'nodeRange') { push @params, "$k=" . &urlize($::in{$k}); }
	  }
	#push @params, 'nodes=' . &urlize(join(',', @nodes));  # is it necessary to urlize this?
	push @params, 'nodes=' . join(',', sort @nodes);
	return join('&', @params);
  }

sub getFirstNode
  {
	foreach my $k (keys %::in) { if ($k =~ /^node\d+/) { return $::in{$k}; } }
	return;
  }
