#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Gather dping options and then run the command

use strict;
#use CGI::Cookie;
BEGIN { $::DEV = $0=~m|csm/device|; $::CSMDIR = $::DEV ? '..' : '.'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();

my $DPING_CMD = ((-x "$GuiUtils::csmroot/bin/dping")?"$GuiUtils::csmroot/bin/dping":undef) || ((-x "/opt/xcsm/bin/dcp")?"/opt/xcsm/bin/dcp":undef);
my $nodeOpt = $::DEV ? '-d' : '-n';
my $NodesStr = $::DEV ? 'Devices' : 'Nodes';
my $NodeStr = $::DEV ? 'Device' : 'Node';
my $nodesStr = $::DEV ? 'devices' : 'nodes';
my $nodeStr = $::DEV ? 'device' : 'node';

GuiUtils->addHeader(undef, 0, "Ping $NodesStr");

if (exists($::in{pingButton}))    # ping nodes and show the cmd output
  {
	print "<H2>Copy Command Output:</H2>\n";
	my $cmd = $DPING_CMD;
	if ($::in{interfacesField}=~/\S/) { $cmd .= " -i " . NodeUtils->quote($::in{interfacesField}); }
	if (exists($::in{summaryCheckbox})) { $cmd .= ' -S'; }
	if (exists($::in{recursiveCheckbox})) { $cmd .= ' -r'; }
	if (exists($::in{serialCheckbox})) { $cmd .= ' -s'; }
	if (exists($::in{verboseCheckbox})) { $cmd .= ' -v'; }
	#$cmd .= " -n $::in{nodes}";
    $cmd .= ' ' . GuiUtils->processNodelist($::in{nodes}, $::DEV?(Device=>1):undef);
	GuiUtils->runcmd($cmd, -1);
	print "<P><BR></P>\n";
	&footer("dping.cgi?nodes=" . &urlize($::in{nodes}), "Ping $NodesStr");
  }
else     # no action yet, just displaying the form
  {
	my $nodping = !$DPING_CMD;
	my $code = GuiUtils->processHTML('dping-src.html');
	eval $code;
	if (length($@)) { print "<P>$@</P>"; }
	&footer('.', $::DEV?'Devices':'CSM Home');
  }
