#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Display options for set up install cmd (csmsetupks or csmsetupyast)

use strict;
BEGIN { $::CSMDIR = '..'; }
use lib "$::CSMDIR";
require GuiUtils;
GuiUtils->init();

GuiUtils->addHeader('setupinstall', 0, 'Set Up Install');

my $what = qq(Hostname,InstallOSName,InstallDistributionName,InstallDistributionVersion,InstallPkgArchitecture);
#my @node_array = split(/,/, $::in{nodes});
my $nodelist = GuiUtils->processNodelist($::in{nodes}, (listNodeAttrs=>1));

my $nodeAttrHoh = GuiUtils->getNodeAttrFromCSMDB($nodelist, $what, 1);
#my $nodeAttrHoh = GuiUtils->reverseHashHash($attrNodeHoh);

foreach my $node (keys %$nodeAttrHoh) {
	my $system = $$nodeAttrHoh{$node}{InstallOSName}
        . " " . $$nodeAttrHoh{$node}{InstallDistributionName}
        . " " . $$nodeAttrHoh{$node}{InstallDistributionVersion}
        . " " . $$nodeAttrHoh{$node}{InstallPkgArchitecture};

	#my $cdpath = "CDPATHNAME" . $system;
	#$::in{"$cdpath"} = "";

	my $config = "CONFIGURATIONFILE" . $system;
	my $defcfg = "";
	if ($$nodeAttrHoh{$node}{InstallDistributionName} =~ /RedHat/) {
		$defcfg = "/opt/csm/install/kscfg.tmpl."
			. $$nodeAttrHoh{$node}{InstallDistributionName}
			. $$nodeAttrHoh{$node}{InstallDistributionVersion};
	} elsif (($$nodeAttrHoh{$node}{InstallDistributionName} =~ /SLES/) ||
		($$nodeAttrHoh{$node}{InstallDistributionName} =~ /SuSE/)) {
		$defcfg = "/opt/csm/install/yastcfg."
			. $$nodeAttrHoh{$node}{InstallDistributionName}
			. $$nodeAttrHoh{$node}{InstallDistributionVersion}
			. "-"
			. $$nodeAttrHoh{$node}{InstallPkgArchitecture}
			. ".xml";
	} else {
		print(qq(Distribution Name $$nodeAttrHoh{$node}{InstallDistributionName} is not supported currently.), "\n");
	}
	$::in{"$config"} = "$defcfg";
}


my $code = GuiUtils->processHTML('setup-src.html');
eval $code;
if (length($@)) { print "<P>$@</P>"; }

GuiUtils->addFooter("./index.cgi", "Install Nodes", \%::in);

