#!/usr/bin/perl
#
#    Cluster Systems Management Webmin Module
#    Copyright (C) 2002 by IBM Corp.
#
# Remove nodes from CSM.

use strict;
use lib $ENV{PWD};
require GuiUtils;
GuiUtils->init();

GuiUtils->addHeader('remove', 0, 'Remove');


if (exists($::in{rmnodeButton}))       # removing nodes
  {
	my $nodestr = GuiUtils->processNodelist($::in{nodes}, (NodeGroup=>1));
	my $cmd = "$GuiUtils::csmroot/bin/rmnode";
	$cmd .= " $nodestr";
	if (exists($::in{uninstall})) { $cmd .= ' -u'; }
	if ($::config{VERBOSE}) { $cmd .= ' -v'; }
	GuiUtils->runcmd($cmd, 1);
	if ($::RUNCMD_RC == 0) {
	  $nodestr =~ s/^-n //i;
	  GuiUtils->msg('I', "Node(s) $nodestr successfully removed from the CSM cluster.");
	}
  }
#else      # just displaying the page

my $code = GuiUtils->processHTML('remove-src.html');
eval $code;
if (length($@)) { print "<P>$@</P>"; }

&footer('', 'CSM Home');




