
Summary: Web Interface for CSM
Name: xcsm.web
Version: 1.1
# This is # of secs since unix epoch divided by secs in a day minus current # of days since unix epoch
# Release: echo '(('`date +%s` '+69120)/(3600*24))-12494' | bc
Release: 18
Group: System Management
Copyright: IBM Corp.
Packager: IBM Corp. <csm@lists.us.ibm.com>
URL: http://techsupport.services.ibm.com/server/csm/utilities/xCSMfixhome.html
Vendor: IBM Corp.
Source0: N/A
NoSource: 0

# AutoReqProv: no

Requires: webmin >= 0.9

%description
Provides a browser-based interface for CSM (Cluster Systems Management) based on webmin.

%files
%defattr( 555, root, root, 755 )

/usr/libexec/webmin/csm/*

# %attr( 555, bin, bin ) /usr/libexec/webmin/csm/GuiUtils.pm
# %attr( 555, bin, bin ) /usr/libexec/webmin/csm/help



%post
# Post-install script---------------------------------------------------

if [ "$1" = 1 ]    # initial install
then
  # Authorize root to use the CSM module
  if [ -e "/etc/webmin/module.infos.cache" ]
  then
  	/bin/rm -f /etc/webmin/module.infos.cache
  fi
  cp /etc/webmin/webmin.acl /etc/webmin/webmin.acl.orig
  perl -e 'while (<>) { if (/^root:/ && !/\bcsm\b/) {s/$/ csm/;} print $_; }' /etc/webmin/webmin.acl.orig >/etc/webmin/webmin.acl

  # Switch the theme to the original webmin theme (because it displays faster).
  #if [ ! -e "/etc/SuSE-release" ]
  #then
    # The necessary steps to change the theme were taken from /usr/libexec/webmin/webmin/change_theme.cgi
    # In the config file, change "theme=blahblah" to "theme="
    cp /etc/webmin/config /etc/webmin/config.orig
    perl -e 'while (<>) { if (/^theme=\S/) {s/=.+$/=/;} print $_; }' /etc/webmin/config.orig >/etc/webmin/config

    # In the miniserv.conf file, remove the "preroot=" line
    cp /etc/webmin/miniserv.conf /etc/webmin/miniserv.conf.orig
    grep -v -E "^preroot=" /etc/webmin/miniserv.conf.orig > /etc/webmin/miniserv.conf

    # Signal the daemon to restart itself
    kill -s SIGHUP `cat /var/webmin/miniserv.pid`
  #fi
fi

if [ "$1" = 1 ] || [ "$1" = 2 ]        # initial install, or upgrade and this is the newer rpm
then
  rm -f /usr/libexec/webmin/csm/root;    ln -s / /usr/libexec/webmin/csm/root
  rm -f /usr/libexec/webmin/csm/web-lib-funcs.pl;    ln -s /usr/libexec/webmin/web-lib-funcs.pl /usr/libexec/webmin/csm/web-lib-funcs.pl
  rm -f /opt/csm/install/templatescripts/pre.SLES.xcsm;   ln -s /usr/libexec/webmin/csm/install/pre.SLES /opt/csm/install/templatescripts/pre.SLES.xcsm
fi

%preun
# Pre-uninstall script -------------------------------------------------

if [ "$1" = 0 ]         # final rpm being removed
then
  rm -f /usr/libexec/webmin/csm/root
  rm -f /usr/libexec/webmin/csm/web-lib-funcs.pl
  rm -f /opt/csm/install/templatescripts/pre.SLES.xcsm

  # should we remove the csm acl from root?
  true
fi
 
